//------------------------------------------------------------------
#property copyright "www,forex-station.com"
#property link      "www,forex-station.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     clrBlue
#property indicator_color2     clrRed
#property indicator_level1     0
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor clrGray
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame2         = PERIOD_CURRENT;    // Time frame
input int              Fast2             = 7;                 // Fast macd ema period
input int              Slow2             = 17;                // Slow macd ema period
input int              Signal2           = 5;                 // Macd signal period
input int              First_R2          = 8;                 // First tsi period
input int              Second_S2         = 5;                 // Second tsi period
input int              SignalPeriod2     = 9;                 // Tsi signal period
enum  enMaTypes
      {
         ma_sma,                                              // Simple moving average
         ma_ema,                                              // Exponential moving average
         ma_smma,                                             // Smoothed MA
         ma_lwma,                                             // Linear weighted MA
      };
input enMaTypes        Mode_Smooth2      = ma_ema;            // Signal ma type  
input bool             alertsOn          = true;              // Alerts true/false?
input bool             alertsOnCurrent   = false;             // Alerts open bar true/false?
input bool             alertsMessage     = true;              // Alerts pop-up message true/false?
input bool             alertsSound       = false;             // Alerts sound true/false?
input bool             alertsNotify      = false;             // Alerts push notification true/false?
input bool             alertsEmail       = false;             // Alerts email true/false?
input string           soundFile         = "alert2.wav";      // Sound file
input bool             Interpolate       = true;              // Interpolate in multi time frame mode


double tsi[],sig[],prc[],trend[],count[];
string indicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame2,indicatorFileName,PERIOD_CURRENT,Fast2,Slow2,Signal2,First_R2,Second_S2,SignalPeriod2,Mode_Smooth2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,_buff,_ind)

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int OnInit()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,tsi,INDICATOR_DATA); SetIndexStyle(0,DRAW_LINE); SetIndexLabel(0,"TSI");
   SetIndexBuffer(1,sig,INDICATOR_DATA); SetIndexStyle(1,DRAW_LINE); SetIndexLabel(1,"TSI Signal");
   SetIndexBuffer(2,prc);
   SetIndexBuffer(3,trend);
   SetIndexBuffer(4,count);
   
   IndicatorSetDouble(INDICATOR_MINIMUM,-110);
   IndicatorSetDouble(INDICATOR_MAXIMUM,100);
   
   indicatorFileName = WindowExpertName();
   TimeFrame2         = fmax(TimeFrame2,_Period); 
   
   IndicatorSetString(INDICATOR_SHORTNAME,timeFrameToString(TimeFrame2)+" TSI_MACD(" +(string)Fast2+ ","+(string)Slow2+","+(string)Signal2+"; " + 
                      (string)First_R2 + ", " + (string)Second_S2 + ", " + (string)SignalPeriod2 + ")");
return(INIT_SUCCEEDED);
}

//
//
//
//
//

int  OnCalculate(const int rates_total,const int prev_calculated,const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int i=rates_total-prev_calculated+1; if (i>=rates_total) i=rates_total-1; count[0]=i;
      if (TimeFrame2!=_Period)
      {
         i = (int)fmax(i,fmin(rates_total-1,_mtfCall(4,0)*TimeFrame2/_Period));
         for (; i>=0 && !_StopFlag; i--)
         {
             int y = iBarShift(NULL,TimeFrame2,time[i]);
                tsi[i] = _mtfCall(0,y);
                sig[i] = _mtfCall(1,y);
                
                //
                //
                //
                //
                //
                     
                if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame2,time[i-1]))) continue;
                  #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                  int n,k; datetime btime = iTime(NULL,TimeFrame2,y);
                     for(n = 1; (i+n)<rates_total && time[i+n] >= btime; n++) continue;	
                     for(k = 1; k<n && (i+n)<rates_total && (i+k)<rates_total; k++) 
                     {
                        _interpolate(tsi); 
                        _interpolate(sig);
                     }                                                                    
              }  
   return(rates_total);
   }
   
   //
   //
   //
         
   for (; i>=0 && !_StopFlag; i--)
   {
      prc[i] = iMACD(NULL,0,Fast2,Slow2,Signal2,PRICE_CLOSE,MODE_MAIN,i);
      double dif = (i<rates_total-1) ? prc[i]-prc[i+1] : 0;
      double avg = iCustomMa(ma_ema,iCustomMa(ma_ema,    (dif),First_R2,i,rates_total,0),Second_S2,i,rates_total,1);
      double ava = iCustomMa(ma_ema,iCustomMa(ma_ema,fabs(dif),First_R2,i,rates_total,2),Second_S2,i,rates_total,3);
      tsi[i] = (ava != 0) ? 100.0*avg/ava : 0;
      sig[i] = iCustomMa(Mode_Smooth2,tsi[i],SignalPeriod2,i,rates_total,4);  
      trend[i] = (i<rates_total-1) ? (tsi[i]>sig[i]) ? 1 : (tsi[i]<sig[i]) ? -1 : trend[i+1] : 0;
   }
   if (alertsOn)
   {
     int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("crossing up");
     else  doAlert("crossing down");       
   }   
return(rates_total);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

string getAvgName(int method)
{
      switch(method)
      {
         case ma_ema:    return("EMA");
         case ma_lwma:   return("LWMA");
         case ma_sma:    return("SMA");
         case ma_smma:   return("SMMA");
      }
return("");      
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define _maInstances 5
#define _maWorkBufferx1 1*_maInstances
#define _maWorkBufferx2 2*_maInstances
#define _maWorkBufferx3 3*_maInstances

double iCustomMa(int mode, double price, double length, int r, int bars, int instanceNo=0)
{
   r = bars-r-1;
   switch (mode)
   {
      case ma_sma   : return(iSma(price,(int)ceil(length),r,bars,instanceNo));
      case ma_ema   : return(iEma(price,length,r,bars,instanceNo));
      case ma_smma  : return(iSmma(price,(int)ceil(length),r,bars,instanceNo));
      case ma_lwma  : return(iLwma(price,(int)ceil(length),r,bars,instanceNo));
      default       : return(price);
   }
}

//
//
//
//
//

double workSma[][_maWorkBufferx1];
double iSma(double price, int period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= _bars) ArrayResize(workSma,_bars);

   workSma[r][instanceNo+0] = price;
   double avg = price; int k=1;  for(; k<period && (r-k)>=0; k++) avg += workSma[r-k][instanceNo+0];  
   return(avg/(double)k);
}

//
//
//
//
//

double workEma[][_maWorkBufferx1];
double iEma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= _bars) ArrayResize(workEma,_bars);

   workEma[r][instanceNo] = price;
   if (r>0 && period>1)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+(2.0/(1.0+period))*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//
//
//
//
//

double workSmma[][_maWorkBufferx1];
double iSmma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= _bars) ArrayResize(workSmma,_bars);

   workSmma[r][instanceNo] = price;
   if (r>1 && period>1)
          workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//
//
//
//
//

double workLwma[][_maWorkBufferx1];
double iLwma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workLwma,0)!= _bars) ArrayResize(workLwma,_bars);
   
   workLwma[r][instanceNo] = price; if (period<=1) return(price);
      double sumw = period;
      double sum  = period*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          
          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" tsi macd "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" tsi macd ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}




